﻿
using HarmonyLib;
using TenCrowns.AppCore;
using TenCrowns.GameCore;

namespace ExtendedInheritanceScreen
{
    public class ExtendedInheritanceScreenClass : ModEntryPointAdapter
    {
        public const string MY_HARMONY_ID = "dale.ExtendedInheritanceScreen.patch";
        public Harmony harmony;

        public override void Initialize(ModSettings modSettings)
        {
            harmony = new Harmony(MY_HARMONY_ID);
            harmony.PatchAll();
        }

        public override void Shutdown()
        {
            harmony.UnpatchAll(MY_HARMONY_ID);
        }
    }

    [HarmonyPatch(typeof(GameFactory), "CreatePlayer")]

    class PatchPlayer
    {
        static bool Prefix(GameFactory __instance)
        {
            return true;
        }

        static void Postfix(ref Player __result)
        {
            __result = new ExtendedInheritanceScreenPlayer();
        }
    }

    [HarmonyPatch(typeof(GameFactory), "CreateCharacter")]

    class PatchCharacter
    {
        static bool Prefix(GameFactory __instance)
        {
            return true;
        }

        static void Postfix(ref Character __result)
        {
            __result = new ExtendedInheritanceScreenCharacter();
        }
    }
}
