﻿
using TenCrowns.GameCore;
using UnityEngine;

namespace ExtendedInheritanceScreen
{
    internal class ExtendedInheritanceScreenPlayer : Player
    {
        public ExtendedInheritanceScreenPlayer() : base()
        {
            return;
        }

        protected override void doFamilies()
        {
            Debug.Log((object)"Turn: " + game().getTurn().ToString() + " - " + getPlayer().ToString());
            if (game().isCharacters())
            {
                foreach (FamilyType eLoopFamily in getFamilies())
                {
                    Debug.Log((object)"Family: " + eLoopFamily.ToString() + " - PlayerNum: " + getPlayer().ToString() + " - Active Characs: " + countActiveCharacters(null, eLoopFamily));
                    if (countActiveCharacters(null, eLoopFamily) < 4)
                    {
                        if (hasFounder())
                        {
                            Debug.Log((object)"Founder: " + eLoopFamily.ToString() + " - " + getPlayer().ToString());
                            Character pCharacter1 = game().createNewCharacter((40 + game().randomNext(10)), getPlayer(), infos().Globals.MALE_GENDER, NameType.NONE, eLoopFamily);
                            pCharacter1.fillValues(3);
                            if (hasFounder())
                            {
                                founder().addChild(pCharacter1.getID());
                                founder().setRetired(true);
                            }
                            else
                            {
                                leader().addChild(pCharacter1.getID());
                            }
                            Debug.Log((object)"Character: " + pCharacter1.getFullName(this, false, null, false, false, false, false, false) + " - " + getFounderID() + " - " + leader().getID());
                            Character pCharacter2 = game().createNewCharacter((40 + game().randomNext(10)), getPlayer(), infos().Globals.FEMALE_GENDER, NameType.NONE, eLoopFamily);
                            pCharacter2.fillValues(3);
                            Debug.Log((object)"Character: " + pCharacter2.getFullName(this, false, null, false, false, false, false, false));
                            pCharacter1.marry(pCharacter2, false);
                            Debug.Log((object)"Family marriage: " + pCharacter1.getFullName(this, false, null, false, false, false, false, false) + " to " + pCharacter2.getFullName(this, false, null, false, false, false, false, false));
                            Character pCharacter3 = game().createNewCharacter((infos().Globals.ADULT_AGE + game().randomNext(10)), getPlayer(), (GenderType)(game().randomNext((int)infos().gendersNum())), NameType.NONE, eLoopFamily);
                            pCharacter3.fillValues(3);
                            pCharacter3.setMotherID(pCharacter2.getID());
                            pCharacter3.setFatherID(pCharacter1.getID());
                            pCharacter1.addChild(pCharacter3.getID());
                            pCharacter2.addChild(pCharacter3.getID());
                            Debug.Log((object)"Family child: " + pCharacter1.getFullName(this, false, null, false, false, false, false, false) + " and " + pCharacter2.getFullName(this, false, null, false, false, false, false, false) + " have a child, " + pCharacter3.getFullName(this, false, null, false, false, false, false, false));
                            Character pCharacter4 = game().createNewCharacter((infos().Globals.ADULT_AGE + game().randomNext(10)), getPlayer(), (GenderType)(game().randomNext((int)infos().gendersNum())), NameType.NONE, eLoopFamily);
                            pCharacter4.fillValues(3);
                            pCharacter4.setMotherID(pCharacter2.getID());
                            pCharacter4.setFatherID(pCharacter1.getID());
                            pCharacter1.addChild(pCharacter4.getID());
                            pCharacter2.addChild(pCharacter4.getID());
                            Debug.Log((object)"Family child: " + pCharacter1.getFullName(this, false, null, false, false, false, false, false) + " and " + pCharacter2.getFullName(this, false, null, false, false, false, false, false) + " have a child, " + pCharacter4.getFullName(this, false, null, false, false, false, false, false));
                            setFamilyHeadID(eLoopFamily, pCharacter1.getID());
                            for (TraitType eLoopTrait = 0; eLoopTrait < infos().traitsNum(); eLoopTrait++)
                            {
                                if (infos().trait(eLoopTrait).mzType == "TRAIT_FAMILY_LINE")
                                {
                                    pCharacter1.addTrait(eLoopTrait);
                                    Debug.Log((object)"Added trait " + infos().trait(eLoopTrait).mzType + " to " + pCharacter1.getFullName(this, false, null, false, false, false, false, false));
                                    pCharacter2.addTrait(eLoopTrait);
                                    Debug.Log((object)"Added trait " + infos().trait(eLoopTrait).mzType + " to " + pCharacter2.getFullName(this, false, null, false, false, false, false, false));
                                    pCharacter3.addTrait(eLoopTrait);
                                    Debug.Log((object)"Added trait " + infos().trait(eLoopTrait).mzType + " to " + pCharacter3.getFullName(this, false, null, false, false, false, false, false));
                                    pCharacter4.addTrait(eLoopTrait);
                                    Debug.Log((object)"Added trait " + infos().trait(eLoopTrait).mzType + " to " + pCharacter4.getFullName(this, false, null, false, false, false, false, false));
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
